From 6e7026dbbba646eeb875dd57e4ad4925d013018c Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:27 +0000
Subject: [PATCH 3/17] Use mock to run api tests.


  - We should use mock to test everything that interacts with database.
  This will avoid some database dependecy problems when runing kiskadee tests.

---

diff --git a/alembic/versions/50988af48b09_create_fetcher_table.py b/alembic/versions/50988af48b09_create_fetcher_table.py
index 33e90a3..54fd6c4 100644
--- a/alembic/versions/50988af48b09_create_fetcher_table.py
+++ b/alembic/versions/50988af48b09_create_fetcher_table.py
@@ -30,7 +30,7 @@ def upgrade():
             primary_key=True
         ),
         sa.Column('name', sa.Unicode(255), nullable=False, unique=True),
-        sa.Column('source', sa.Unicode(255), nullable=True),
+        sa.Column('target', sa.Unicode(255), nullable=True),
         sa.Column('description', sa.UnicodeText)
     )
 
diff --git a/alembic/versions/cc4887b7c3da_create_fetchers_on_database.py b/alembic/versions/cc4887b7c3da_create_fetchers_on_database.py
index 01ec98c..bd88705 100644
--- a/alembic/versions/cc4887b7c3da_create_fetchers_on_database.py
+++ b/alembic/versions/cc4887b7c3da_create_fetchers_on_database.py
@@ -23,7 +23,7 @@ def upgrade():
     fetchers_table = table('fetchers',
             column('id', Integer),
             column('name', String),
-            column('source', String),
+            column('target', String),
             column('description', String)
             )
 
@@ -35,7 +35,7 @@ def upgrade():
                 [
                     {
                         'id': idx, 'name': _fetcher.name,
-                        'source': _fetcher.config['source'],
+                        'target': _fetcher.config['target'],
                         'description': _fetcher.config['description']
                         }
                     ]
diff --git a/kiskadee/tests/api/test_api.py b/kiskadee/tests/api/test_api.py
index e88fee5..0b83d1a 100644
--- a/kiskadee/tests/api/test_api.py
+++ b/kiskadee/tests/api/test_api.py
@@ -1,8 +1,10 @@
 import json
 import unittest
+from sqlalchemy.orm import sessionmaker
 from unittest.mock import MagicMock
 
 import kiskadee
+from kiskadee.runner import Runner
 from kiskadee.monitor import Monitor
 import kiskadee.api.app
 import kiskadee.fetchers.example
diff --git a/kiskadee/tests/integration/test_monitor.py b/kiskadee/tests/integration/test_monitor.py
index 67cd7c2..aa95be6 100644
--- a/kiskadee/tests/integration/test_monitor.py
+++ b/kiskadee/tests/integration/test_monitor.py
@@ -3,8 +3,8 @@ from sqlalchemy.orm import sessionmaker
 
 from kiskadee import model
 from kiskadee.monitor import Monitor
-from kiskadee.queue import Queues
-from kiskadee.model import Package, create_analyzers, Report, Analysis
+from kiskadee.queue import packages_queue
+from kiskadee.model import Package, Fetcher, create_analyzers, Report, Analysis
 import kiskadee.queue
 import kiskadee.fetchers.debian
 import kiskadee.fetchers.anitya
@@ -18,13 +18,12 @@ class MonitorTestCase(unittest.TestCase):
         Session = sessionmaker(bind=self.engine)
         self.session = Session()
         self.monitor = Monitor(self.session)
-        self.queues = Queues()
         model.Base.metadata.create_all(self.engine)
         create_analyzers(self.session)
         self.pkg1 = {
                 'name': 'curl',
                 'version': '7.52.1-5',
-                'fetcher': kiskadee.fetchers.debian.__name__,
+                'fetcher': kiskadee.fetchers.debian,
                 'meta': {'directory': 'pool/main/c/curl'},
                 'results': {
                     'cppcheck': '<>',
@@ -33,7 +32,7 @@ class MonitorTestCase(unittest.TestCase):
 
         self.pkg2 = {'name': 'urlscan',
                      'version': '0.8.2',
-                     'fetcher': kiskadee.fetchers.debian.__name__,
+                     'fetcher': kiskadee.fetchers.debian,
                      'meta': {'directory': 'pool/main/u/urlscan'},
                      'results': {
                             'cppcheck': '<>',
@@ -42,7 +41,7 @@ class MonitorTestCase(unittest.TestCase):
 
         self.pkg3 = {'name': 'curl',
                      'version': '7.52.2-5',
-                     'fetcher': kiskadee.fetchers.debian.__name__,
+                     'fetcher': kiskadee.fetchers.debian,
                      'meta': {'directory': 'pool/main/c/curl'},
                      'results': {
                             'cppcheck': '<>',
@@ -50,7 +49,7 @@ class MonitorTestCase(unittest.TestCase):
                      'fetcher_id': 1}
         self.pkg4 = {'name': 'urlanitya',
                      'version': '0.11',
-                     'fetcher': kiskadee.fetchers.anitya.__name__,
+                     'fetcher': kiskadee.fetchers.anitya,
                      'meta': {
                             'backend': 'gitHub',
                             'homepage': 'https://github.com/GesielFreitas/Cros'
@@ -79,14 +78,31 @@ class MonitorTestCase(unittest.TestCase):
         fetcher = kiskadee.fetchers.debian.Fetcher()
         self.assertEqual(fetcher.name, 'debian')
 
+    def test_save_some_fetcher(self):
+        fetcher = kiskadee.fetchers.debian.Fetcher()
+        self.monitor._save_fetcher(fetcher)
+        _fetchers = self.monitor.session.query(Fetcher).all()
+        self.assertEqual(len(_fetchers), 1)
+        self.assertEqual(_fetchers[0].name, 'debian')
+        self.assertEqual(_fetchers[0].description,
+                         fetcher.config['description'])
+
     def test_save_package(self):
         self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.monitor._save_analyzed_project(self.pkg1)
-        self.monitor._save_analyzed_project(self.pkg2)
+        packages_queue.put(self.pkg1)
+        packages_queue.put(self.pkg2)
+
+        _pkg = self.monitor.dequeue_package()
+        self.monitor._save_analyzed_pkg(_pkg)
+        _pkgs = self.monitor.session.query(Package).all()
+        self.assertEqual(len(_pkgs), 1)
+        self.assertEqual(_pkgs[0].name, _pkg['name'])
+
+        _pkg = self.monitor.dequeue_package()
+        self.monitor._save_analyzed_pkg(_pkg)
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 2)
-        self.assertEqual(_pkgs[0].name, self.pkg1['name'])
-        self.assertEqual(_pkgs[1].name, self.pkg2['name'])
+        self.assertEqual(_pkgs[1].name, _pkg['name'])
 
     def test_save_reports(self):
         _fetcher = model.Fetcher(
@@ -126,21 +142,21 @@ class MonitorTestCase(unittest.TestCase):
 
     def test_save_version(self):
         self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.monitor._save_analyzed_project(self.pkg1)
+        self.monitor._save_analyzed_pkg(self.pkg1)
         _pkgs = self.monitor.session.query(Package).all()
         _version = _pkgs[0].versions[0].number
         self.assertEqual(_version, self.pkg1['version'])
 
     def test_update_version(self):
         self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.queues.enqueue_project(self.pkg1)
-        self.queues.enqueue_project(self.pkg3)
+        packages_queue.put(self.pkg1)
+        packages_queue.put(self.pkg3)
 
-        _pkg = self.queues.dequeue_project()
-        self.monitor._save_analyzed_project(_pkg)
+        _pkg = self.monitor.dequeue_package()
+        self.monitor._save_analyzed_pkg(_pkg)
 
-        _pkg = self.queues.dequeue_project()
-        self.monitor._save_analyzed_project(_pkg)
+        _pkg = self.monitor.dequeue_package()
+        self.monitor._save_analyzed_pkg(_pkg)
 
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 1)
@@ -155,9 +171,11 @@ class MonitorTestCase(unittest.TestCase):
 
     def test_save_package_anitya(self):
         self.monitor._save_fetcher(kiskadee.fetchers.anitya.Fetcher())
-        self.queues.enqueue_project(self.pkg4)
-        _pkg = self.queues.dequeue_project()
-        self.monitor._save_analyzed_project(_pkg)
+        packages_queue.put(self.pkg4)
+
+        _pkg = self.monitor.dequeue_package()
+        self.monitor._save_analyzed_pkg(_pkg)
+
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 1)
         self.assertEqual(_pkgs[0].homepage, _pkg['meta']['homepage'])
diff --git a/kiskadee/tests/integration/test_runner.py b/kiskadee/tests/integration/test_runner.py
index f9a2e16..0ad1e0a 100644
--- a/kiskadee/tests/integration/test_runner.py
+++ b/kiskadee/tests/integration/test_runner.py
@@ -1,8 +1,3 @@
-"""
-This integration tests needs docker engine be running and accessible
-by the user that is executing the tests. It also needs selinux running in
-a permissive mode (setenforce 0)
-"""
 import unittest
 import tempfile
 
@@ -11,11 +6,12 @@ import kiskadee.fetchers.example
 import kiskadee.fetchers.debian
 from sqlalchemy.orm import sessionmaker
 from kiskadee import model
-from kiskadee.queue import Queues
+from kiskadee.queue import KiskadeeQueue
 from kiskadee.database import Database
 
 
 class AnalyzersTestCase(unittest.TestCase):
+
     def setUp(self):
         self.engine = Database('db_test').engine
         Session = sessionmaker(bind=self.engine)
@@ -25,15 +21,16 @@ class AnalyzersTestCase(unittest.TestCase):
         self.fetcher = kiskadee.fetchers.debian.Fetcher()
         self.deb_pkg = {'name': 'test',
                         'version': '1.0.0',
-                        'fetcher': kiskadee.fetchers.debian.__name__
+                        'fetcher': kiskadee.fetchers.debian.Fetcher()
                         }
         self.fetcher = model.Fetcher(
                 name='kiskadee-fetcher2', target='university'
             )
         self.session.add(self.fetcher)
         self.session.commit()
+        kiskadee_queue = KiskadeeQueue()
         self.runner = Runner()
-        self.runner.queues = Queues()
+        self.runner.kiskadee_queue = kiskadee_queue
 
     def tearDown(self):
         self.session.close()
@@ -57,11 +54,12 @@ class AnalyzersTestCase(unittest.TestCase):
         source_to_analysis = {
                 'name': 'test',
                 'version': '1.0.0',
-                'fetcher': kiskadee.fetchers.example.__name__
+                'fetcher': kiskadee.fetchers.example.Fetcher()
         }
 
         self.runner.call_analyzers(source_to_analysis)
-        analyzed_pkg = self.runner.queues.dequeue_result()
+        analyzed_pkg = self.runner.kiskadee_queue.dequeue_result()
+
         self.assertEqual(analyzed_pkg['name'], source_to_analysis['name'])
         self.assertIn('cppcheck', analyzed_pkg['results'])
         self.assertIn('flawfinder', analyzed_pkg['results'])
@@ -95,6 +93,5 @@ class AnalyzersTestCase(unittest.TestCase):
 
         self.assertIsNone(source_path)
 
-
 if __name__ == '__main__':
     unittest.main()
diff --git a/kiskadee/tests/plugins/test_plugins.py b/kiskadee/tests/plugins/test_plugins.py
index 9fe8262..030da9a 100644
--- a/kiskadee/tests/plugins/test_plugins.py
+++ b/kiskadee/tests/plugins/test_plugins.py
@@ -70,7 +70,7 @@ class DebianFetcherTestCase(unittest.TestCase):
         self.debian_fetcher._queue_sources_gz_pkgs(temp_dir)
         shutil.rmtree(temp_dir)
 
-        some_pkg = kiskadee.queue.Queues.dequeue_project()
+        some_pkg = kiskadee.queue.packages_queue.get()
         self.assertTrue(isinstance(some_pkg, dict))
         self.assertIn('name', some_pkg)
         self.assertIn('version', some_pkg)
@@ -190,8 +190,8 @@ class TestAnityaFetcher(unittest.TestCase):
 
     def test_create_package_dict(self):
 
-        self.anitya_fetcher.project_to_enqueue(self.msg)
-        _dict = kiskadee.queue.Queues().dequeue_project()
+        self.anitya_fetcher._create_package_dict(self.msg)
+        _dict = kiskadee.queue.packages_queue.get()
         self.assertEqual(_dict['name'], 'urlscan')
         self.assertEqual(_dict['version'], '0.8.5')
         self.assertEqual(_dict['meta']['backend'], 'GitHub')
@@ -199,7 +199,7 @@ class TestAnityaFetcher(unittest.TestCase):
                 _dict['meta']['homepage'],
                 'https://github.com/firecat53/urlscan'
         )
-        self.assertEqual(_dict['fetcher'], 'kiskadee.fetchers.anitya')
+        self.assertEqual(_dict['fetcher'].name, 'anitya')
 
 
 if __name__ == '__main__':
diff --git a/util/kiskadee.conf b/util/kiskadee.conf
index 5eb6ec8..c2dc351 100644
--- a/util/kiskadee.conf
+++ b/util/kiskadee.conf
@@ -19,7 +19,7 @@ port = 5432
 dbname = kiskadee_test
 
 [debian_fetcher]
-source = http://ftp.us.debian.org/debian
+target = http://ftp.us.debian.org/debian
 description = A fetcher to monitor Debian Repositories
 release = sid
 meta = Sources.gz
@@ -28,13 +28,13 @@ analyzers = cppcheck flawfinder
 active = no
 
 [juliet_fetcher]
-source = juliet
+target = juliet
 description = SAMATE Juliet test suite
 analyzers = cppcheck
 active = no
 
 [anitya_fetcher]
-source = release-monitoring.org
+target = release-monitoring.org
 description = A fetcher to monitor Anitya packages
 analyzers = cppcheck flawfinder
 active = no
@@ -42,7 +42,7 @@ zmq_port = 5556
 zmq_topic = anitya
 
 [example_fetcher]
-source = example
+target = example
 description = SAMATE Juliet test suite
 analyzers = cppcheck flawfinder clanganalyzer frama_c
 active = yes

